package CicleANN;

import Case.ICase;
import CaseBase.ICaseBase;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;
import RetrieveReuse.*;

/**
 * Classe principal de l'algorisme ANN.
 */
public class ANN implements IANN{
    @Override
    public Collection<ICase> executeANN(ICaseBase caseBase, String dataset, String fileTrain, Collection<ICase> trainCases) {
        double[] minAttributeValues = caseBase.getMinAttributeValues();
        double[] maxAttributeValues = caseBase.getMaxAttributeValues();	
        Retrieve retrieve = new Retrieve();
        Reuse reuse = new Reuse();
        //Amb la k=3 diem quantes distàncies avalua l'algorisme
        int k = 3;
        List <ICase> copyTrainingSet = new ArrayList<ICase>();
        Collection <ICase> removeCases = new ArrayList<ICase>();
        
        //copia del trainingSet perque si esborrem un cas del conjunt mentres es fa el for dona problemes
        for(ICase c : caseBase.trainCases()){
            copyTrainingSet.add(c);
        }
        
        boolean classified;
        
        /* ANN Algorithm:
        *
        * T: Training Set
        * 
        * Repeat
        *              For all x E T do
        *                      set m = 1
        *                      While m <= k+1 do
        *                              Eliminar x de T si aquest classifica malament x utilitzant m-NN
        *                              m = m+1
        *              End-For
        * Until not changes
        *
        * Return T     
        */
        
        for(ICase c : caseBase.trainCases()){
            if(!c.isClassified()){
                c.setClassifiedTrue();
                classified = false; //centinela trobat
                int m = 0;
                while(m < k+1 && !classified){
                    m++;
                    ArrayList<ICase> retrievedCases = new ArrayList<ICase>();
                    retrievedCases = retrieve.retrieveCases(c, copyTrainingSet, minAttributeValues, maxAttributeValues, m);
                    String classe = reuse.reviseCases(retrievedCases);
                    if (c.getAttributeClass().equals(classe)) {					
                        classified = true; // Hem classificat el cas incorrectament ==> missclassified = true						
                    }

                }

                if(!classified){
                    copyTrainingSet.remove(c);
                    removeCases.add(c);
                    c.setNoise();
                }
            }
        }        
        
        return removeCases;
    }

}