package CicleBBNR;

import Case.ICase;
import CaseBase.ICaseBase;
import RetrieveReuse.Retrieve;
import RetrieveReuse.Reuse;
import java.util.ArrayList;
import java.util.Iterator;

/**
 * Classe principal de la classe CoverageLiability.
 */
public class CoverageLiability implements ICoverageLiability{
    
    @Override
    public void createCoverageAndLiabilitySets(int numK, ICaseBase caseBase, Reuse reuse, Retrieve retrieve, double[] minAttributeValues, double[] maxAttributeValues){
        //crear conjunts
        for(ICase c: caseBase.trainCases()){
            c.setClassifiedTrue();
            ArrayList<ICase> neighbors = retrieve.retrieveCases(c,caseBase.trainCases(),minAttributeValues,maxAttributeValues,numK);

            String classe = reuse.reviseCases(neighbors);

            //Si el cas el classifica be l'afegim al conjunt de Coverage del cas "c"
            if(classe.equals(c.getAttributeClass())){
                ICase aux = null;
                if(numK > 1){
                    Iterator itr = neighbors.iterator();
                    while(itr.hasNext()) {
                        ICase element = (ICase) itr.next();
                        if(element.getAttributeClass().equals(classe)){
                            aux = caseBase.getCaseC(element);
                            if(!aux.getCoverageSet().contains(c)){
                                aux.addCaseToCoverageSet(c);
                            }
                        }
                    }
                }else{
                    aux = caseBase.getCaseC(neighbors.get(0));
                    if(!aux.getCoverageSet().contains(c)){
                        aux.addCaseToCoverageSet(c);
                    }
                }

            //Si el cas no classifica be el cas l'afegim al conjunt Liability del cas "c"
            }else{
                ICase aux = null;
                if(numK > 1){
                    Iterator itr = neighbors.iterator();
                    while(itr.hasNext()) {
                        ICase element = (ICase) itr.next();
                        if(!element.getAttributeClass().equals(classe)){                            
                            aux = caseBase.getCaseC(element);
                            if(!aux.getLiabilitySet().contains(c)){
                                aux.addCaseToLiabilitySet(c);
                            }
                        }
                    }
                }else{
                    aux = caseBase.getCaseC(neighbors.get(0));
                    if(!aux.getLiabilitySet().contains(c)){
                        aux.addCaseToLiabilitySet(c);
                    }
                }
                
                
            }
        }      
    }
}
