package CicleCRR;

import Case.ICase;
import CaseBase.ICaseBase;
import RetrieveReuse.Retrieve;
import RetrieveReuse.Reuse;
import java.util.ArrayList;
import java.util.Iterator;

public class CoverageSet implements ICoverageSet{
    /**
     * Mètode per crear el conjunt de coverage
     * @param numK
     * @param caseBase
     * @param reuse
     * @param retrieve
     * @param minAttributeValues
     * @param maxAttributeValues 
     */
    @Override
    public void createCoverageSet(int numK, ICaseBase caseBase, Reuse reuse, Retrieve retrieve, double[] minAttributeValues, double[] maxAttributeValues){
        //crear conjunts
        for(ICase c: caseBase.trainCases()){
            c.setClassifiedTrue();
            ArrayList<ICase> neighbors = retrieve.retrieveCases(c,caseBase.trainCases(),minAttributeValues,maxAttributeValues,numK);

            String classe = reuse.reviseCases(neighbors);

            //Si el cas el classifica be l'afegim al conjunt de Coverage del cas "c"
            if(classe.equals(c.getAttributeClass())){
                //k>1
                ICase aux = null;
                if(numK > 1){
                    Iterator itr = neighbors.iterator();
                    while(itr.hasNext()) {
                        ICase element = (ICase) itr.next();
                        if(element.getAttributeClass().equals(classe)){
                            aux = caseBase.getCaseC(element);
                            if(!aux.getCoverageSet().contains(c)){
                                aux.addCaseToCoverageSet(c);
                            }
                        }
                    }
                }else{
                    //k=1
                    aux = caseBase.getCaseC(neighbors.get(0));
                    if(!aux.getCoverageSet().contains(c)){
                        aux.addCaseToCoverageSet(c);
                    }
                }
            }
        }
    }
}
